#/function terra_system:items/chest/tier_1/copper/give
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Don't display equip message
#DontMakeSound Temp - Don't make sound on equipping
#Method Temp - What method the item should take to generate - default = give, 1 = summon, 2 = data merge, 3 = replace item
#MessageMethod Temp - What method to display message to player - default = actionbar, 1 = chat
#CustomName Temp - Makes item show name
#Invulnerable Temp - Makes item Invulnerable
#NoGravity Temp - Makes item NoGravity
#PickupDelay Temp - Makes item have a custom PickupDelay
#Age Temp - Makes item have a custom Age
#FunctionPickup Temp - If item should use the custom pickup function
#WeaponSlot Temp - Slot weapon should be equipped to - default = 1
#Offhand Temp - If replace item should place weapon in offhand

function terra_system:items/on_give1

#Chest ID
scoreboard players set @s IDChest 1

#Give item
execute unless score Method Temp matches 1.. run replaceitem entity @s armor.chest minecraft:leather_chestplate{ItemTexture:"copper",CustomModelData:0,DeleteOnDrop:0,display:{color:16777215,Name:'{"translate":"terra.items.copper_chestplate","color":"white","bold":true}',Lore:['{"translate":""}','[{"translate":"terra.items.tier","color":"blue"},{"translate":" 1","color":"blue"}]','[{"translate":"terra.items.item_level","color":"blue"},{"translate":" 1","color":"blue"}]','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.copper.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+1 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]','[{"translate":"+2 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"chest",AttributeName:"generic.max_health",Amount:180,Operation:0,Name:"generic.max_health",UUID:[I;12799,7872,18671,11971]}],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorChestCopper","ArmorChest"]}

#Summon item
execute if score Method Temp matches 1 run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:leather_chestplate",Count:1b,tag:{ItemTexture:"copper",CustomModelData:0,DeleteOnDrop:0,display:{color:16777215,Name:'{"translate":"terra.items.copper_chestplate","color":"white","bold":true}',Lore:['{"translate":""}','[{"translate":"terra.items.tier","color":"blue"},{"translate":" 1","color":"blue"}]','[{"translate":"terra.items.item_level","color":"blue"},{"translate":" 1","color":"blue"}]','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.copper.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+1 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]','[{"translate":"+2 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"chest",AttributeName:"generic.max_health",Amount:180,Operation:0,Name:"generic.max_health",UUID:[I;15875,7964,17507,29981]}],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorChestCopper","ArmorChest"]}},Tags:["TempNewItem"]}

#Data merge item
execute if score Method Temp matches 2 run data merge entity @s {Item:{id:"minecraft:leather_chestplate",Count:1b,tag:{ItemTexture:"copper",CustomModelData:0,DeleteOnDrop:0,display:{color:16777215,Name:'{"translate":"terra.items.copper_chestplate","color":"white","bold":true}',Lore:['{"translate":""}','[{"translate":"terra.items.tier","color":"blue"},{"translate":" 1","color":"blue"}]','[{"translate":"terra.items.item_level","color":"blue"},{"translate":" 1","color":"blue"}]','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.copper.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+1 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]','[{"translate":"+2 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"chest",AttributeName:"generic.max_health",Amount:180,Operation:0,Name:"generic.max_health",UUID:[I;30957,9191,18917,31245]}],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorChestCopper","ArmorChest"]}}}
execute if score Method Temp matches 2 run tag @s add TempNewItem

#Replace item
execute if score Method Temp matches 3 run replaceitem entity @s armor.chest minecraft:leather_chestplate{ItemTexture:"copper",CustomModelData:0,DeleteOnDrop:0,display:{color:16777215,Name:'{"translate":"terra.items.copper_chestplate","color":"white","bold":true}',Lore:['{"translate":""}','[{"translate":"terra.items.tier","color":"blue"},{"translate":" 1","color":"blue"}]','[{"translate":"terra.items.item_level","color":"blue"},{"translate":" 1","color":"blue"}]','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.copper.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+1 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]','[{"translate":"+2 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"chest",AttributeName:"generic.max_health",Amount:180,Operation:0,Name:"generic.max_health",UUID:[I;9681,24993,32059,20906]}],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorChestCopper","ArmorChest"]}

#Set attributes
execute unless score Method Temp matches 1.. run function terra_system:stats/reset_stats_chest
execute unless score Method Temp matches 1.. run scoreboard players set @s HealthChest 0
execute unless score Method Temp matches 1.. run scoreboard players set @s SpiritChest 0
execute unless score Method Temp matches 1.. run scoreboard players set @s StamChest 0
execute unless score Method Temp matches 1.. run scoreboard players set @s OffenseChest 1
execute unless score Method Temp matches 1.. run scoreboard players set @s DefenseChest 2
execute unless score Method Temp matches 1.. run execute unless score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats
execute unless score Method Temp matches 1.. run execute if score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats_no_message

#Set properties
function terra_system:items/on_give2
execute if score CustomName Temp matches 1..2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.copper_chestplate","color":"white"}',CustomNameVisible:1}
execute if score CustomName Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.copper","color":"white"}',CustomNameVisible:1}
execute if score FunctionPickup Temp matches 1 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionGlobal","FunctionGlobalItem","Item_ArmorChestCopper"]}
execute if score FunctionPickup Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionItem","Item_ArmorChestCopper"]}
tag @e remove TempNewItem

#Display message
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute unless score MessageMethod Temp matches 1.. run title @s actionbar {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.copper_chestplate","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute if score MessageMethod Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.copper_chestplate","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}

#Sound
execute unless score DontMakeSound Temp matches 1 run playsound minecraft:item.armor.equip_diamond player @a

#Run function again if still need to give more
scoreboard players set LoopStarted Temp 1
scoreboard players remove Amount Temp 1
execute unless score Method Temp matches 1.. run execute if score Amount Temp matches 1.. run function terra_system:items/chest/tier_1/copper/give

	
	
		
#Clean up
function terra_system:items/on_give3


