#/function terra_system:items/head/tier_1/barrel/give
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Don't display equip message
#DontMakeSound Temp - Don't make sound on equipping
#Method Temp - What method the item should take to generate - default = give, 1 = summon, 2 = data merge, 3 = replace item
#MessageMethod Temp - What method to display message to player - default = actionbar, 1 = chat
#CustomName Temp - Makes item show name
#Invulnerable Temp - Makes item Invulnerable
#NoGravity Temp - Makes item NoGravity
#PickupDelay Temp - Makes item have a custom PickupDelay
#Age Temp - Makes item have a custom Age
#FunctionPickup Temp - If item should use the custom pickup function
#WeaponSlot Temp - Slot weapon should be equipped to - default = 1
#Offhand Temp - If replace item should place weapon in offhand

function terra_system:items/on_give1

#Head ID
scoreboard players set TerraRestore IDHead 1

#Give item
execute unless score Method Temp matches 1.. run replaceitem entity @s armor.head minecraft:diamond_helmet{ItemTexture:"-",display:{color:16777215,Name:'{"translate":"terra.items.helmet_barrel","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.helmet_barrel.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorHeadBarrel","ArmorHead"]}

#Summon item
execute if score Method Temp matches 1 run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:diamond_helmet",Count:1b,tag:{ItemTexture:"-",display:{color:16777215,Name:'{"translate":"terra.items.helmet_barrel","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.helmet_barrel.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorHeadBarrel","ArmorHead"]}},Tags:["TempNewItem"]}

#Data merge item
execute if score Method Temp matches 2 run data merge entity @s {Item:{id:"minecraft:diamond_helmet",Count:1b,tag:{ItemTexture:"-",display:{color:16777215,Name:'{"translate":"terra.items.helmet_barrel","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.helmet_barrel.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorHeadBarrel","ArmorHead"]}}}
execute if score Method Temp matches 2 run tag @s add TempNewItem

#Replace item
execute if score Method Temp matches 3 run replaceitem entity @s armor.head minecraft:diamond_helmet{ItemTexture:"-",display:{color:16777215,Name:'{"translate":"terra.items.helmet_barrel","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":"terra.items.helmet_barrel.lore1","color":"gray","italic":true}','{"translate":""}','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.defense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:71,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],ItemTags:["Item_ArmorHeadBarrel","ArmorHead"]}

#Set attributes
execute unless score Method Temp matches 1.. run function terra_system:stats/reset_stats_head
execute unless score Method Temp matches 1.. run scoreboard players set @s HealthHead 0
execute unless score Method Temp matches 1.. run scoreboard players set @s SpiritHead 0
execute unless score Method Temp matches 1.. run scoreboard players set @s StamHead 0
execute unless score Method Temp matches 1.. run scoreboard players set @s OffenseHead 0
execute unless score Method Temp matches 1.. run scoreboard players set @s DefenseHead 10
execute unless score Method Temp matches 1.. run execute unless score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats
execute unless score Method Temp matches 1.. run execute if score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats_no_message

#Set properties
function terra_system:items/on_give2
execute if score CustomName Temp matches 1..2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.helmet_barrel","color":"white"}',CustomNameVisible:1}
execute if score CustomName Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.helmet_barrel","color":"white"}',CustomNameVisible:1}
execute if score FunctionPickup Temp matches 1 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionGlobal","FunctionGlobalItem","Item_ArmorHeadBarrel"]}
execute if score FunctionPickup Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionItem","Item_ArmorHeadBarrel"]}
tag @e remove TempNewItem

#Display message
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute unless score MessageMethod Temp matches 1.. run title @s actionbar {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.helmet_barrel","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute if score MessageMethod Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.helmet_barrel","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}

#Sound
execute unless score DontMakeSound Temp matches 1 run playsound minecraft:item.armor.equip_diamond player @a

#Run function again if still need to give more
scoreboard players set LoopStarted Temp 1
scoreboard players remove Amount Temp 1
execute unless score Method Temp matches 1.. run execute if score Amount Temp matches 1.. run function terra_system:items/head/tier_1/barrel/give

	execute as @e[tag=PlayerStriderArmor] at @s run function terra_system:items/head/update_strider_armor
	
		
#Clean up
function terra_system:items/on_give3


