#/function terra_system:items/weapons/melee/tier_1/falchion/give
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Don't display equip message
#DontMakeSound Temp - Don't make sound on equipping
#Method Temp - What method the item should take to generate - default = give, 1 = summon, 2 = data merge, 3 = replace item
#MessageMethod Temp - What method to display message to player - default = actionbar, 1 = chat
#CustomName Temp - Makes item show name
#Invulnerable Temp - Makes item Invulnerable
#NoGravity Temp - Makes item NoGravity
#PickupDelay Temp - Makes item have a custom PickupDelay
#Age Temp - Makes item have a custom Age
#FunctionPickup Temp - If item should use the custom pickup function
#WeaponSlot Temp - Slot weapon should be equipped to - default = 1
#Offhand Temp - If replace item should place weapon in offhand

function terra_system:items/on_give1

#Clear all current weapons
execute unless score WeaponSlot Temp matches 2.. run scoreboard players set TerraRestore IDWeaponSlot1 0
execute if score WeaponSlot Temp matches 2 run scoreboard players set TerraRestore IDWeaponSlot2 0
execute unless score Method Temp matches 1.. run function terra_system:items/weapons/clear_weapons

#Weapon ID
execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set TerraRestore IDWeaponSlot1 1
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set TerraRestore IDWeaponSlot2 1

#Give item
execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run give @s minecraft:diamond_sword{CustomModelData:1,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.falchion","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":""}','[{"translate":"+5.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:4.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;11409,27247,21228,3614]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;4164,17143,30198,23766]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeFalchion","WeaponMelee","WeaponSlot1"]}
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run give @s minecraft:diamond_sword{CustomModelData:1,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.falchion","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":""}','[{"translate":"+5.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:4.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;27392,24179,29476,21283]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;23267,19233,6672,2198]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeFalchion","WeaponMelee","WeaponSlot2"]}

#Summon item
execute if score Method Temp matches 1 run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:diamond_sword",Count:1b,tag:{CustomModelData:1,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.falchion","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":""}','[{"translate":"+5.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:4.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;3604,21047,22616,2155]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;2634,31423,15870,27323]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeFalchion","WeaponMelee","WeaponSlot2"]}},Tags:["TempNewItem"]}

#Data merge item
execute if score Method Temp matches 2 run data merge entity @s {Item:{id:"minecraft:diamond_sword",Count:1b,tag:{CustomModelData:1,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.falchion","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":""}','[{"translate":"+5.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:4.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;3470,11941,8463,3571]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;27713,13839,9347,1156]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeFalchion","WeaponMelee","WeaponSlot2"]}}}
execute if score Method Temp matches 2 run tag @s add TempNewItem

#Replace item
execute if score Method Temp matches 3 run execute unless score Offhand Temp matches 1 run replaceitem entity @s weapon.mainhand minecraft:diamond_sword{CustomModelData:1,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.falchion","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":""}','[{"translate":"+5.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:4.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;4192,31980,9829,2780]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;32263,22224,22836,6550]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeFalchion","WeaponMelee","WeaponSlot2"]}
execute if score Method Temp matches 3 run execute if score Offhand Temp matches 1 run replaceitem entity @s weapon.offhand minecraft:diamond_sword{CustomModelData:1,DeleteOnDrop:1,display:{Name:'{"translate":"terra.items.falchion","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}','{"translate":""}','[{"translate":"+5.0 ","color":"blue"},{"translate":"terra.stats.melee_damage","color":"blue"}]','[{"translate":"+10 ","color":"blue"},{"translate":"terra.stats.offense","color":"blue"}]']},RepairCost:100,Unbreakable:1,AttributeModifiers:[{Slot:"mainhand",AttributeName:"generic.attack_damage",Amount:4.000000,Operation:0,Name:"generic.attack_damage",UUID:[I;308,13567,3208,26605]},{Slot:"mainhand",AttributeName:"generic.attack_speed",Amount:1024.0f,Operation:0,Name:"generic.attack_speed",UUID:[I;26830,712,26872,29303]}],HideFlags:7,Enchantments:[{id:"minecraft:sweeping",lvl:1s}],ItemTags:["Item_WeaponsMeleeFalchion","WeaponMelee","WeaponSlot2"]}

#Set attributes
execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run function terra_system:stats/reset_stats_weapon1
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run function terra_system:stats/reset_stats_weapon2

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s HealthWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s HealthWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s SpiritWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s SpiritWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s StamWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s StamWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s OffenseWeapon1 10
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s OffenseWeapon2 10

execute unless score Method Temp matches 1.. run execute unless score WeaponSlot Temp matches 2.. run scoreboard players set @s DefenseWeapon1 0
execute unless score Method Temp matches 1.. run execute if score WeaponSlot Temp matches 2 run scoreboard players set @s DefenseWeapon2 0

execute unless score Method Temp matches 1.. run execute unless score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats
execute unless score Method Temp matches 1.. run execute if score DontDisplayMessage Temp matches 1 run function terra_system:stats/calculate_stats_no_message

#Set properties
function terra_system:items/on_give2
execute if score CustomName Temp matches 1..2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.falchion","color":"white"}',CustomNameVisible:1}
execute if score CustomName Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.falchion.short_name","color":"white"}',CustomNameVisible:1}
execute if score FunctionPickup Temp matches 1 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionGlobal","FunctionGlobalItem","Item_WeaponsMeleeFalchion"]}
execute if score FunctionPickup Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionItem","Item_WeaponsMeleeFalchion"]}
tag @e remove TempNewItem

#Display message
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute unless score MessageMethod Temp matches 1.. run title @s actionbar {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.falchion","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute if score MessageMethod Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"["},{"translate":"terra.items.falchion","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.equipped"}]}

#Sound
execute unless score DontMakeSound Temp matches 1 run playsound minecraft:item.armor.equip_diamond player @a

#Run function again if still need to give more
scoreboard players set LoopStarted Temp 1
scoreboard players remove Amount Temp 1
execute unless score Method Temp matches 1.. run execute if score Amount Temp matches 1.. run function terra_system:items/weapons/melee/tier_1/falchion/give

		
#Clean up
function terra_system:items/on_give3


